; Image1 Ver.1.1
; Copyright (C) 2011 saguruma
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

; *** RAM reserve ***
Image1_data_LSB    = $DB
Image1_data_MSB    = $DC
Image1_chr_bank    = $DD

Image1_index       = $031E

; *** constants ***
Image1_BASE1_LSB   = $88
Image1_BASE1_MSB   = $20
Image1_BASE2_LSB   = $CA
Image1_BASE2_MSB   = $23

;******************************************************************************
; main
;******************************************************************************
Image1_main:
  inc <currentActivity
  ldx <currentActivity
  lda activities, x
  asl a
  tax
  lda Image1_main_VECTOR, x
  sta <address1_LSB
  inx
  lda Image1_main_VECTOR, x
  sta <address1_MSB
  jmp [address1_LSB]

Image1_main_VECTOR:
  .dw Image1_fadeout          ; #0 tF[hAEg
  .dw Image1_getDataAddress   ; #1 AhX擾
  .dw Image1_loadPallet       ; #2 pbg[h
  .dw Image1_loadBG           ; #3 BG/Attr[h
  .dw Image1_fadein           ; #4 tF[hC
  .dw Image1_terminate        ; #5 J

;******************************************************************************
; terminate
;******************************************************************************
Image1_terminate:
  ldx <currentActivity
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  sta activities, x
  sta processCounters, x
  rts


;******************************************************************************
; getDataAddress
;******************************************************************************
Image1_getDataAddress:
  lda #0
  jsr MMC_changePRG

  lda Image1_index
  asl a
  tay
  lda Image1_datavector, y
  sta <Image1_data_LSB
  iny
  lda Image1_datavector, y
  sta <Image1_data_MSB

  ldy #0
  lda [Image1_data_LSB], y
  sta <Image1_chr_bank
  jsr MMC_changeCHR_High

  lda <Image1_data_LSB
  clc
  adc #1
  sta <Image1_data_LSB
  lda <Image1_data_MSB
  adc #0
  sta <Image1_data_MSB
  ldx <currentActivity
  inc activities, x
  rts


;******************************************************************************
; load Pallet
;******************************************************************************
Image1_loadPallet:
  lda #0
  jsr MMC_changePRG

  lda #low(Adv_pallet)+4
  sta <address2_LSB
  lda #high(Adv_pallet)
  sta <address2_MSB
  ldy #0
.loop:
  lda [Image1_data_LSB], y
  sta [address2_LSB], y
  sta REG_PPU_7
  iny
  cpy #12
  bcc .loop
  lda <Image1_data_LSB
  clc
  adc #12
  sta <Image1_data_LSB
  lda <Image1_data_MSB
  adc #0
  sta <Image1_data_MSB
  ldx <currentActivity
  inc activities, x
  rts


;******************************************************************************
; loadBG
;******************************************************************************
Image1_loadBG:
  lda #0
  jsr MMC_changePRG

  lda #0
  sta <work1
  tay
.loop0:
  lda #Image1_BASE1_LSB
  sta <address1_LSB
  lda #Image1_BASE1_MSB
  sta <address1_MSB
  lda <work1
  lsr a
  lsr a
  lsr a
  clc
  adc <address1_MSB
  sta <address1_MSB
  lda <work1
  asl a
  asl a
  asl a
  asl a
  asl a
  clc
  adc <address1_LSB
  sta <address1_LSB
  bcc .storeAddress1
  inc <address1_MSB
.storeAddress1:
  lda REG_PPU_2
  lda <address1_MSB
  sta REG_PPU_6
  lda <address1_LSB
  sta REG_PPU_6
  lda #0
  sta <work2
.loop1:
  lda [Image1_data_LSB], y
  sta REG_PPU_7
  iny
  inc <work2
  lda <work2
  cmp #18
  bcc .loop1
  inc <work1
  lda <work1
  cmp #10
  bcc .loop0
  lda #0
  sta <work1
  tay
  lda <Image1_data_LSB
  clc
  adc #180
  sta <Image1_data_LSB
  lda <Image1_data_MSB
  adc #0
  sta <Image1_data_MSB
.loop2:
  lda #Image1_BASE2_LSB
  sta <address1_LSB
  lda #Image1_BASE2_MSB
  sta <address1_MSB
  lda <work1
  asl a
  asl a
  asl a
  clc
  adc <address1_LSB
  sta <address1_LSB
  bcc .storeAddress2
  inc <address1_MSB
.storeAddress2:
  lda REG_PPU_2
  lda <address1_MSB
  sta REG_PPU_6
  lda <address1_LSB
  sta REG_PPU_6
  lda #0
  sta <work2
.loop3:
  lda [Image1_data_LSB], y
  sta REG_PPU_7
  iny
  inc <work2
  lda <work2
  cmp #5
  bcc .loop3
  inc <work1
  lda <work1
  cmp #3
  bcc .loop2
  ldx <currentActivity
  inc activities, x
  rts



;******************************************************************************
; fadein
;******************************************************************************
Image1_fadein:
  lda Adv_skip
  and #$7F ; [htÕNA
  sta Adv_skip
  lda #low(Adv_pallet)
  sta <address1_LSB
  lda #high(Adv_pallet)
  sta <address1_MSB
  jmp Util_fadein


;******************************************************************************
; fadeout
;******************************************************************************
Image1_fadeout:
  lda Adv_skip
  cmp #$80
  beq .skip ; [hȂ̂ŃtF[hAEgXLbv
  lda #low(Adv_pallet)
  sta <address1_LSB
  lda #high(Adv_pallet)
  sta <address1_MSB
  jmp Util_fadeout
.skip:
  ldx <currentActivity
  inc activities, x
  rts


