; Image2 Ver.1.1
; Copyright (C) 2011 saguruma
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

; *** RAM reserve ***
Image2_data_LSB    = $DE
Image2_data_MSB    = $DF

Image2_index       = $031F

; *** constants ***
Image2_BASE_X      = 16
Image2_BASE_Y      = 87

;******************************************************************************
; main
;******************************************************************************
Image2_main:
  inc <currentActivity
  ldx <currentActivity
  lda activities, x
  asl a
  tax
  lda Image2_main_VECTOR, x
  sta <address1_LSB
  inx
  lda Image2_main_VECTOR, x
  sta <address1_MSB
  jmp [address1_LSB]

Image2_main_VECTOR:
  .dw Image2_fadeout          ; #0 tF[hAEg
  .dw Image2_getDataAddress   ; #1 AhX擾
  .dw Image2_loadPallet       ; #2 pbg[h
  .dw Image2_loadSP           ; #3 SP/Attr[h
  .dw Image2_fadein           ; #4 tF[hC
  .dw Image2_terminate        ; #5 J

;******************************************************************************
; terminate
;******************************************************************************
Image2_terminate:
  ldx <currentActivity
  lda #0
  sta activities, x
  sta processCounters, x
  dex
  sta activities, x
  sta processCounters, x
  rts


;******************************************************************************
; getDataAddress
;******************************************************************************
Image2_getDataAddress:
  lda #0
  jsr MMC_changePRG

  lda Image2_index
  asl a
  tay
  lda Image2_datavector, y
  sta <Image2_data_LSB
  iny
  lda Image2_datavector, y
  sta <Image2_data_MSB

  ldx <currentActivity
  inc activities, x
  rts


;******************************************************************************
; load Pallet
;******************************************************************************
Image2_loadPallet:
  lda #0
  jsr MMC_changePRG

  lda #low(Adv_pallet)+16
  sta <address2_LSB
  lda #high(Adv_pallet)
  sta <address2_MSB
  ldy #0
.loop:
  lda [Image2_data_LSB], y
  sta [address2_LSB], y
  sta REG_PPU_7
  iny
  cpy #12
  bcc .loop
  lda <Image2_data_LSB
  clc
  adc #12
  sta <Image2_data_LSB
  lda <Image2_data_MSB
  adc #0
  sta <Image2_data_MSB
  ldx <currentActivity
  inc activities, x
  rts


;******************************************************************************
; loadSP
;******************************************************************************
Image2_loadSP:
  lda #0
  jsr MMC_changePRG

  lda #0
  sta <work1
  tay
  ldx #16
.loop0:
  lda #0
  sta <work2
.loop1:
  lda #Image2_BASE_Y
  clc
  adc <work1
  sta SPRITE_Y, x
  lda #Image2_BASE_X
  clc
  adc <work2
  sta SPRITE_X, x
  lda [Image2_data_LSB], y
  iny
  sta SPRITE_I, x
  lda [Image2_data_LSB], y
  iny
  sta SPRITE_A, x
  inx
  inx
  inx
  inx
  lda <work2
  clc
  adc #8
  sta <work2
  cmp #32
  bcc .loop1
  lda <work1
  clc
  adc #8
  sta <work1
  cmp #32
  bcc .loop0
  ldx <currentActivity
  inc activities, x
  rts



;******************************************************************************
; fadein
;******************************************************************************
Image2_fadein:
  lda #low(Adv_pallet)
  sta <address1_LSB
  lda #high(Adv_pallet)
  sta <address1_MSB
  ldx <currentActivity
  lda processCounters, x
  asl a
  asl a
  asl a
  asl a
  eor #$FF
  and #$30
  sta <work1

  lda REG_PPU_2
  lda #$3F
  sta REG_PPU_6
  lda #$10
  sta REG_PPU_6
  tay
.loop0:
  lda [address1_LSB], y
  sec
  sbc <work1
  bmi .setBlack
  sta REG_PPU_7
  iny
  cpy #$1C
  bcc .loop0
  bcs .next
.setBlack:
  lda #$0F
  sta REG_PPU_7
  iny
  cpy #$1C
  bcc .loop0
.next:
  ldx <currentActivity
  inc processCounters, x
  lda processCounters, x
  cmp #4
  bcc .continue
  lda #0
  sta processCounters, x
  inc activities, x
.continue:
  rts


;******************************************************************************
; fadeout
;******************************************************************************
Image2_fadeout:
  lda #low(Adv_pallet)
  sta <address1_LSB
  lda #high(Adv_pallet)
  sta <address1_MSB
  ldx <currentActivity
  lda processCounters, x
  asl a
  asl a
  asl a
  asl a
  clc
  adc #$10
  and #$70
  sta <work1

  lda REG_PPU_2
  lda #$3F
  sta REG_PPU_6
  lda #$10
  sta REG_PPU_6
  tay
.loop0:
  lda [address1_LSB], y
  sec
  sbc <work1
  bmi .setBlack
  sta REG_PPU_7
  iny
  cpy #$1C
  bcc .loop0
  bcs .next
.setBlack:
  lda #$0F
  sta REG_PPU_7
  iny
  cpy #$1C
  bcc .loop0
.next:
  ldx <currentActivity
  inc processCounters, x
  lda processCounters, x
  cmp #4
  bcc .continue
  lda #0
  sta processCounters, x
  inc activities, x
.continue:
  rts


