; Random Number Generator Module Version 1.1
; Copyright (C) 2011 saguruma
;
; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

; *** RAM reserve ***
RNG_crc_LSB        = $EE
RNG_crc_MSB        = $EF
RNG_rand           = $EE ; CRC LSB

;******************************************************************************
; Update CRC
;******************************************************************************
RNG_updateCRC:
  php
  pha

  eor <RNG_crc_MSB
  sta <RNG_crc_MSB
  txa
  pha
  ldx #$08
.crc_1:
  lda <RNG_crc_LSB
  asl a
  sta <RNG_crc_LSB
  lda <RNG_crc_MSB
  rol a
  sta <RNG_crc_MSB
  bcc .crc_2
  lda <RNG_crc_LSB
  eor #$21
  sta <RNG_crc_LSB
  lda <RNG_crc_MSB
  eor #$10
  sta <RNG_crc_MSB
.crc_2:
  dex
  bne .crc_1
  pla
  tax

  pla
  plp
  rts

;******************************************************************************
; Update RandomNumber
;******************************************************************************
RNG_updateRN:
  lda #$FF
  jsr RNG_updateCRC
  lda #$FF
  jsr RNG_updateCRC
  rts
